/**
 *  Copyright notice
 *  
 *  This file is part of the Processing sketch `Stimulated Emission' 
 *  http://www.gwoptics.org/processing/stimulated_emission/
 *
 *  Copyright (C) 2009 onwards Mengyao Wang and Andreas Freise
 *  based on an idea by Emil Schreiber.
 *
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  as published by the Free Software Foundation; either version 2
 *  of the License, or (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, 
 *  MA  02110-1301, USA.
 */

public class Atom {
  PVector loc;  
  int state;
  PApplet _parent;    

  Atom(PApplet parent, int s) {
    _parent=parent;
    loc = new PVector(random(laser_x1,laser_x2),random(laser_y1,laser_y2));
    state = s;
  }

  void run() {
    update(); 
    borders();
    render();
  }

  void update() {
    PVector vel = new PVector(random(-1,1)*random(0,2),random(-1,1)*random(0,2));
    loc.add(vel);
  }

  void render() {
    _parent.fill(state*255);
    _parent.stroke(state*255);
    _parent.pushMatrix();
    _parent.translate(loc.x,loc.y);
    _parent.beginShape(TRIANGLES);
    _parent.vertex(0, -3);
    _parent.vertex(-3, 3);
    _parent.vertex(3, 3);
    _parent.endShape();
    _parent.popMatrix();
  }

  void borders() {
    if (loc.x < laser_x1-2) loc.x = laser_x1+2;
    if (loc.y < laser_y1+10) loc.y = laser_y1+10;
    if (loc.x > laser_x2-2) loc.x = laser_x2-8;
    if (loc.y > laser_y2-10) loc.y = laser_y2-10;
  }
}

